#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/delay.h>


unsigned char F,he,hd,me,md,sec,rezim;
unsigned char F_INT0,F_INT1,F1;

ISR (TIMER1_COMPA_vect){ //  
	
	if (F==0)
	{
		PORTB |= _BV(PB4);
		F=1;
	} else {
		PORTB &= ~_BV(PB4);
		F=0;
	}
	sec++;
	if (sec==60){
		sec=0;
		me++;
		if (me==10){
			me=0;
			md++;
			if (md == 6) {
				md=0;	
				he++;
				if (he == 10) {
					he=0;
					hd++;
				}
				if (hd==2) {
					if (he==4){
						he=0;
						hd=0;
					}
				}
			}
		}
	}
}
void Enable_N0(void) //   .
{
	PORTC &= ~_BV(PC5);
	PORTC &= ~_BV(PC4);
	PORTC &= ~_BV(PC1);
	PORTC &= ~_BV(PC0);
}
void Enable_N1(void) //   1
{
	PORTC |=  _BV(PC5);
	PORTC &= ~_BV(PC4);
	PORTC &= ~_BV(PC1);
	PORTC &= ~_BV(PC0);
}
void Enable_N2(void) //   2
{
	PORTC &= ~_BV(PC5);
	PORTC |=  _BV(PC4);
	PORTC &= ~_BV(PC1);
	PORTC &= ~_BV(PC0);
}
void Enable_N3(void) //   3
{
	PORTC &= ~_BV(PC5);
	PORTC &= ~_BV(PC4);
	PORTC |=  _BV(PC1);
	PORTC &= ~_BV(PC0);
}
void Enable_N4(void) //   4
{
	PORTC &= ~_BV(PC5);
	PORTC &= ~_BV(PC4);
	PORTC &= ~_BV(PC1);
	PORTC |=  _BV(PC0);
}

void Code1(void) //  1
{
	PORTB |=  _BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC |=  _BV(PC2); //d
	PORTB |=  _BV(PB5); //e
	PORTD |=  _BV(PD0); //f
	PORTD |=  _BV(PD1); //g
}
void Code2(void) //  2
{
	PORTB &= ~_BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC |=  _BV(PC3); //c
	PORTC &= ~_BV(PC2); //d
	PORTB &= ~_BV(PB5); //e
	PORTD |=  _BV(PD0); //f
	PORTD &= ~_BV(PD1); //g
}
void Code3(void)//  3
{
	PORTB &= ~_BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC &= ~_BV(PC2); //d
	PORTB |=  _BV(PB5); //e
	PORTD |=  _BV(PD0); //f
	PORTD &= ~_BV(PD1); //g
}
void Code4(void)//  4
{
	PORTB |=  _BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC |=  _BV(PC2); //d
	PORTB |=  _BV(PB5); //e
	PORTD &= ~_BV(PD0); //f
	PORTD &= ~_BV(PD1); //g
}
void Code5(void)//  5
{
	PORTB &= ~_BV(PB2); //a
	PORTB |=  _BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC &= ~_BV(PC2); //d
	PORTB |=  _BV(PB5); //e
	PORTD &= ~_BV(PD0); //f
	PORTD &= ~_BV(PD1); //g
}
void Code6(void)//  6
{
	PORTB &= ~_BV(PB2); //a
	PORTB |=  _BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC &= ~_BV(PC2); //d
	PORTB &= ~_BV(PB5); //e
	PORTD &= ~_BV(PD0); //f
	PORTD &= ~_BV(PD1); //g
}
void Code7(void)//  7
{
	PORTB &= ~_BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC |=  _BV(PC2); //d
	PORTB |=  _BV(PB5); //e
	PORTD |=  _BV(PD0); //f
	PORTD |=  _BV(PD1); //g
}
void Code8(void)//  8
{
	PORTB &= ~_BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC &= ~_BV(PC2); //d
	PORTB &= ~_BV(PB5); //e
	PORTD &= ~_BV(PD0); //f
	PORTD &= ~_BV(PD1); //g
}
void Code9(void)//  9
{
	PORTB &= ~_BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC &= ~_BV(PC2); //d
	PORTB |=  _BV(PB5); //e
	PORTD &= ~_BV(PD0); //f
	PORTD &= ~_BV(PD1); //g
}
void Code0(void)//  0
{
	PORTB &= ~_BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC &= ~_BV(PC2); //d
	PORTB &= ~_BV(PB5); //e
	PORTD &= ~_BV(PD0); //f
	PORTD |=  _BV(PD1); //g
}
void Code10(void)//  
{
	PORTB |= _BV(PB2); //a
	PORTB |= _BV(PB3); //b
	PORTC |= _BV(PC3); //c
	PORTC |= _BV(PC2); //d
	PORTB |= _BV(PB5); //e
	PORTD |= _BV(PD0); //f
	PORTD |= _BV(PD1); //g
}
void Show_All(void) //      
{
	PORTB &= ~_BV(PB2); //a
	PORTB &= ~_BV(PB3); //b
	PORTC &= ~_BV(PC3); //c
	PORTC &= ~_BV(PC2); //d
	PORTB &= ~_BV(PB5); //e
	PORTD &= ~_BV(PD0); //f
	PORTD &= ~_BV(PD1); //g
	PORTC |=  _BV(PC5);
	PORTC |=  _BV(PC4);
	PORTC |=  _BV(PC1);
	PORTC |=  _BV(PC0        );
}

void Show_Code(unsigned char CN, unsigned char EN) // CN -   , EN -   
{
	Enable_N0();

	switch (CN){
		case 1:
			Code1();
		break;
		case 2:
			Code2();
		break;
		case 3:
			Code3();
		break;
		case 4:
			Code4();
		break;
		case 5:
			Code5();
		break;
		case 6:
			Code6();
		break;
		case 7:
			Code7();
		break;
		case 8:
			Code8();
		break;
		case 9:
			Code9();
		break;
		case 0:
			Code0();
		break;
		case 10:
			Code10();
		break;
	};
	switch (EN){
		case 1:
			Enable_N1();
		break;
		case 2:
			Enable_N2();
		break;
		case 3:
			Enable_N3();
		break;
		case 4:
			Enable_N4();
		break;
	};
	_delay_ms(1);
}

void init(void)//  ,   .
{
	F=0;
	rezim=0;
//   
	TCCR1A = _BV(COM1A0);
	TCCR1B = _BV(CS12) | _BV(WGM12);
	OCR1A=31250; // 8000000/256

//      
	TCCR0 = _BV(CS02);
	F1=0;
TIMSK = 0b00010001;
	
	
//    INT0
	GICR |= _BV(INT0); //    INT0
	DDRD &= ~_BV(PD2);
	PORTD |= _BV(PD2);
	F_INT0=0;
//    INT1
	GICR |= _BV(INT1); //    INT1
	DDRD &= ~_BV(PD3);
	PORTD |= _BV(PD3);
	F_INT1=0;


// Enadleds
	DDRC = _BV(PC5) | _BV(PC4) | _BV(PC1) | _BV(PC0) | _BV(PC3) | _BV(PC2);
	
// Codes
	DDRB = _BV(PB5) | _BV(PB3) | _BV(PB2);
	DDRD = _BV(PD1) | _BV(PD0);
	
//Signal
	DDRB |= _BV(PB4);
}

// a - PB2
// b - PB3
// c - PC3
// d - PC2
// e - PB5
// f - PD0
// g - PD1

// PC0 - +4
// PC1 - +3
// PC4 - +2
// PC5 - +1


// rezim
// =0 -  
// =1 -   ()
// =2 -   ()
// =3 -   ()
// =4 -   ()

ISR (INT0_vect){ //    
	if (F_INT0==0){
		MCUCR = _BV(ISC01) | _BV(ISC00);
		F_INT0=1;
		_delay_ms(10);
	}else{
		MCUCR = ~_BV(ISC01) & ~_BV(ISC00);
		F_INT0=0;
		_delay_ms(10);
		TIMSK &= ~_BV (OCIE1A);
		PORTB |= _BV(PB4);
		F=1;
		rezim++;
		switch (rezim){
			case 1:
			break;
			case 2:
			break;
			case 3:
			break;
			case 4:
			break;
			case 5:
				rezim=0;
				F=0;
				PORTB &= ~_BV(PB4);
				TIMSK |= _BV (OCIE1A);
			break;
		}
	}
}

ISR (INT1_vect){ //   
	if (F_INT1==0){
		MCUCR = _BV(ISC11) | _BV(ISC10);
		F_INT1=1;
		_delay_ms(20);
	}else{
		MCUCR = ~_BV(ISC11) & ~_BV(ISC10);
		F_INT1=0;
		_delay_ms(20);
		
		switch (rezim){
			case 1:
				hd++;
				if (hd>2) {hd=0;}
			break;
			case 2:
				he++;
				if (he>9) {he=0;}
			break;
			case 3:
				md++;
				if (md>5) {md=0;}
			break;
			case 4:
				me++;
				if (me>9) {me=0;}
			break;
		}
	}
}

void Update_Display(void){ //  
	switch (rezim){
		case 0:
			Show_Code(hd,1);
			Show_Code(he,2);
			Show_Code(md,3);
			Show_Code(me,4);
		break;
		case 1:
			if (F1<20) {Show_Code(hd,1);}
			Show_Code(he,2);
			Show_Code(md,3);
			Show_Code(me,4);
		break;
		case 2:
			Show_Code(hd,1);
			if (F1<20) {Show_Code(he,2);}
			Show_Code(md,3);
			Show_Code(me,4);
		break;
		case 3:
			Show_Code(hd,1);
			Show_Code(he,2);
			if (F1<20) {Show_Code(md,3);}
			Show_Code(me,4);
		break;
		case 4:
			Show_Code(hd,1);
			Show_Code(he,2);
			Show_Code(md,3);
			if (F1<20) {Show_Code(me,4);}
		break;
	}
}

ISR (TIMER0_OVF_vect){ 
	F1++;
	if (F1==40) { F1=0; }
}


// -------   ---------
void main(void)
{

	sei ();
	
	init();	
	
	hd=0;
	he=0;
	md=0;
	me=0;
	sec=0;
	
	Show_All();
	
while(1) {                   //  
	Update_Display();

}
}
